/**
 * Autogenerated by Thrift Compiler (1.0.0-dev)
 *
 * DO NOT EDIT UNLESS YOU ARE SURE THAT YOU KNOW WHAT YOU ARE DOING
 *  @generated
 */
package jayeson.vodds.service.cms.thrift;

import org.apache.thrift.scheme.IScheme;
import org.apache.thrift.scheme.SchemeFactory;
import org.apache.thrift.scheme.StandardScheme;

import org.apache.thrift.scheme.TupleScheme;
import org.apache.thrift.protocol.TTupleProtocol;
import org.apache.thrift.protocol.TProtocolException;
import org.apache.thrift.EncodingUtils;
import org.apache.thrift.TException;
import org.apache.thrift.async.AsyncMethodCallback;
import org.apache.thrift.server.AbstractNonblockingServer.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.EnumMap;
import java.util.Set;
import java.util.HashSet;
import java.util.EnumSet;
import java.util.Collections;
import java.util.BitSet;
import java.nio.ByteBuffer;
import java.util.Arrays;
import javax.annotation.Generated;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@SuppressWarnings({"cast", "rawtypes", "serial", "unchecked"})
@Generated(value = "Autogenerated by Thrift Compiler (1.0.0-dev)", date = "2022-4-26")
public class ThriftUserUpdate implements org.apache.thrift.TBase<ThriftUserUpdate, ThriftUserUpdate._Fields>, java.io.Serializable, Cloneable, Comparable<ThriftUserUpdate> {
  private static final org.apache.thrift.protocol.TStruct STRUCT_DESC = new org.apache.thrift.protocol.TStruct("ThriftUserUpdate");

  private static final org.apache.thrift.protocol.TField C_UPDATES_FIELD_DESC = new org.apache.thrift.protocol.TField("cUpdates", org.apache.thrift.protocol.TType.LIST, (short)1);
  private static final org.apache.thrift.protocol.TField M_UPDATES_FIELD_DESC = new org.apache.thrift.protocol.TField("mUpdates", org.apache.thrift.protocol.TType.LIST, (short)2);

  private static final Map<Class<? extends IScheme>, SchemeFactory> schemes = new HashMap<Class<? extends IScheme>, SchemeFactory>();
  static {
    schemes.put(StandardScheme.class, new ThriftUserUpdateStandardSchemeFactory());
    schemes.put(TupleScheme.class, new ThriftUserUpdateTupleSchemeFactory());
  }

  public List<ThriftCreditUpdate> cUpdates; // optional
  public List<ThriftMplUpdate> mUpdates; // optional

  /** The set of fields this struct contains, along with convenience methods for finding and manipulating them. */
  public enum _Fields implements org.apache.thrift.TFieldIdEnum {
    C_UPDATES((short)1, "cUpdates"),
    M_UPDATES((short)2, "mUpdates");

    private static final Map<String, _Fields> byName = new HashMap<String, _Fields>();

    static {
      for (_Fields field : EnumSet.allOf(_Fields.class)) {
        byName.put(field.getFieldName(), field);
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, or null if its not found.
     */
    public static _Fields findByThriftId(int fieldId) {
      switch(fieldId) {
        case 1: // C_UPDATES
          return C_UPDATES;
        case 2: // M_UPDATES
          return M_UPDATES;
        default:
          return null;
      }
    }

    /**
     * Find the _Fields constant that matches fieldId, throwing an exception
     * if it is not found.
     */
    public static _Fields findByThriftIdOrThrow(int fieldId) {
      _Fields fields = findByThriftId(fieldId);
      if (fields == null) throw new IllegalArgumentException("Field " + fieldId + " doesn't exist!");
      return fields;
    }

    /**
     * Find the _Fields constant that matches name, or null if its not found.
     */
    public static _Fields findByName(String name) {
      return byName.get(name);
    }

    private final short _thriftId;
    private final String _fieldName;

    _Fields(short thriftId, String fieldName) {
      _thriftId = thriftId;
      _fieldName = fieldName;
    }

    public short getThriftFieldId() {
      return _thriftId;
    }

    public String getFieldName() {
      return _fieldName;
    }
  }

  // isset id assignments
  private static final _Fields optionals[] = {_Fields.C_UPDATES,_Fields.M_UPDATES};
  public static final Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> metaDataMap;
  static {
    Map<_Fields, org.apache.thrift.meta_data.FieldMetaData> tmpMap = new EnumMap<_Fields, org.apache.thrift.meta_data.FieldMetaData>(_Fields.class);
    tmpMap.put(_Fields.C_UPDATES, new org.apache.thrift.meta_data.FieldMetaData("cUpdates", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRUCT            , "ThriftCreditUpdate"))));
    tmpMap.put(_Fields.M_UPDATES, new org.apache.thrift.meta_data.FieldMetaData("mUpdates", org.apache.thrift.TFieldRequirementType.OPTIONAL, 
        new org.apache.thrift.meta_data.ListMetaData(org.apache.thrift.protocol.TType.LIST, 
            new org.apache.thrift.meta_data.FieldValueMetaData(org.apache.thrift.protocol.TType.STRUCT            , "ThriftMplUpdate"))));
    metaDataMap = Collections.unmodifiableMap(tmpMap);
    org.apache.thrift.meta_data.FieldMetaData.addStructMetaDataMap(ThriftUserUpdate.class, metaDataMap);
  }

  public ThriftUserUpdate() {
  }

  /**
   * Performs a deep copy on <i>other</i>.
   */
  public ThriftUserUpdate(ThriftUserUpdate other) {
    if (other.isSetCUpdates()) {
      List<ThriftCreditUpdate> __this__cUpdates = new ArrayList<ThriftCreditUpdate>(other.cUpdates.size());
      for (ThriftCreditUpdate other_element : other.cUpdates) {
        __this__cUpdates.add(other_element);
      }
      this.cUpdates = __this__cUpdates;
    }
    if (other.isSetMUpdates()) {
      List<ThriftMplUpdate> __this__mUpdates = new ArrayList<ThriftMplUpdate>(other.mUpdates.size());
      for (ThriftMplUpdate other_element : other.mUpdates) {
        __this__mUpdates.add(other_element);
      }
      this.mUpdates = __this__mUpdates;
    }
  }

  public ThriftUserUpdate deepCopy() {
    return new ThriftUserUpdate(this);
  }

  @Override
  public void clear() {
    this.cUpdates = null;
    this.mUpdates = null;
  }

  public int getCUpdatesSize() {
    return (this.cUpdates == null) ? 0 : this.cUpdates.size();
  }

  public java.util.Iterator<ThriftCreditUpdate> getCUpdatesIterator() {
    return (this.cUpdates == null) ? null : this.cUpdates.iterator();
  }

  public void addToCUpdates(ThriftCreditUpdate elem) {
    if (this.cUpdates == null) {
      this.cUpdates = new ArrayList<ThriftCreditUpdate>();
    }
    this.cUpdates.add(elem);
  }

  public List<ThriftCreditUpdate> getCUpdates() {
    return this.cUpdates;
  }

  public ThriftUserUpdate setCUpdates(List<ThriftCreditUpdate> cUpdates) {
    this.cUpdates = cUpdates;
    return this;
  }

  public void unsetCUpdates() {
    this.cUpdates = null;
  }

  /** Returns true if field cUpdates is set (has been assigned a value) and false otherwise */
  public boolean isSetCUpdates() {
    return this.cUpdates != null;
  }

  public void setCUpdatesIsSet(boolean value) {
    if (!value) {
      this.cUpdates = null;
    }
  }

  public int getMUpdatesSize() {
    return (this.mUpdates == null) ? 0 : this.mUpdates.size();
  }

  public java.util.Iterator<ThriftMplUpdate> getMUpdatesIterator() {
    return (this.mUpdates == null) ? null : this.mUpdates.iterator();
  }

  public void addToMUpdates(ThriftMplUpdate elem) {
    if (this.mUpdates == null) {
      this.mUpdates = new ArrayList<ThriftMplUpdate>();
    }
    this.mUpdates.add(elem);
  }

  public List<ThriftMplUpdate> getMUpdates() {
    return this.mUpdates;
  }

  public ThriftUserUpdate setMUpdates(List<ThriftMplUpdate> mUpdates) {
    this.mUpdates = mUpdates;
    return this;
  }

  public void unsetMUpdates() {
    this.mUpdates = null;
  }

  /** Returns true if field mUpdates is set (has been assigned a value) and false otherwise */
  public boolean isSetMUpdates() {
    return this.mUpdates != null;
  }

  public void setMUpdatesIsSet(boolean value) {
    if (!value) {
      this.mUpdates = null;
    }
  }

  public void setFieldValue(_Fields field, Object value) {
    switch (field) {
    case C_UPDATES:
      if (value == null) {
        unsetCUpdates();
      } else {
        setCUpdates((List<ThriftCreditUpdate>)value);
      }
      break;

    case M_UPDATES:
      if (value == null) {
        unsetMUpdates();
      } else {
        setMUpdates((List<ThriftMplUpdate>)value);
      }
      break;

    }
  }

  public Object getFieldValue(_Fields field) {
    switch (field) {
    case C_UPDATES:
      return getCUpdates();

    case M_UPDATES:
      return getMUpdates();

    }
    throw new IllegalStateException();
  }

  /** Returns true if field corresponding to fieldID is set (has been assigned a value) and false otherwise */
  public boolean isSet(_Fields field) {
    if (field == null) {
      throw new IllegalArgumentException();
    }

    switch (field) {
    case C_UPDATES:
      return isSetCUpdates();
    case M_UPDATES:
      return isSetMUpdates();
    }
    throw new IllegalStateException();
  }

  @Override
  public boolean equals(Object that) {
    if (that == null)
      return false;
    if (that instanceof ThriftUserUpdate)
      return this.equals((ThriftUserUpdate)that);
    return false;
  }

  public boolean equals(ThriftUserUpdate that) {
    if (that == null)
      return false;

    boolean this_present_cUpdates = true && this.isSetCUpdates();
    boolean that_present_cUpdates = true && that.isSetCUpdates();
    if (this_present_cUpdates || that_present_cUpdates) {
      if (!(this_present_cUpdates && that_present_cUpdates))
        return false;
      if (!this.cUpdates.equals(that.cUpdates))
        return false;
    }

    boolean this_present_mUpdates = true && this.isSetMUpdates();
    boolean that_present_mUpdates = true && that.isSetMUpdates();
    if (this_present_mUpdates || that_present_mUpdates) {
      if (!(this_present_mUpdates && that_present_mUpdates))
        return false;
      if (!this.mUpdates.equals(that.mUpdates))
        return false;
    }

    return true;
  }

  @Override
  public int hashCode() {
    List<Object> list = new ArrayList<Object>();

    boolean present_cUpdates = true && (isSetCUpdates());
    list.add(present_cUpdates);
    if (present_cUpdates)
      list.add(cUpdates);

    boolean present_mUpdates = true && (isSetMUpdates());
    list.add(present_mUpdates);
    if (present_mUpdates)
      list.add(mUpdates);

    return list.hashCode();
  }

  @Override
  public int compareTo(ThriftUserUpdate other) {
    if (!getClass().equals(other.getClass())) {
      return getClass().getName().compareTo(other.getClass().getName());
    }

    int lastComparison = 0;

    lastComparison = Boolean.valueOf(isSetCUpdates()).compareTo(other.isSetCUpdates());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetCUpdates()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.cUpdates, other.cUpdates);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    lastComparison = Boolean.valueOf(isSetMUpdates()).compareTo(other.isSetMUpdates());
    if (lastComparison != 0) {
      return lastComparison;
    }
    if (isSetMUpdates()) {
      lastComparison = org.apache.thrift.TBaseHelper.compareTo(this.mUpdates, other.mUpdates);
      if (lastComparison != 0) {
        return lastComparison;
      }
    }
    return 0;
  }

  public _Fields fieldForId(int fieldId) {
    return _Fields.findByThriftId(fieldId);
  }

  public void read(org.apache.thrift.protocol.TProtocol iprot) throws org.apache.thrift.TException {
    schemes.get(iprot.getScheme()).getScheme().read(iprot, this);
  }

  public void write(org.apache.thrift.protocol.TProtocol oprot) throws org.apache.thrift.TException {
    schemes.get(oprot.getScheme()).getScheme().write(oprot, this);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder("ThriftUserUpdate(");
    boolean first = true;

    if (isSetCUpdates()) {
      sb.append("cUpdates:");
      if (this.cUpdates == null) {
        sb.append("null");
      } else {
        sb.append(this.cUpdates);
      }
      first = false;
    }
    if (isSetMUpdates()) {
      if (!first) sb.append(", ");
      sb.append("mUpdates:");
      if (this.mUpdates == null) {
        sb.append("null");
      } else {
        sb.append(this.mUpdates);
      }
      first = false;
    }
    sb.append(")");
    return sb.toString();
  }

  public void validate() throws org.apache.thrift.TException {
    // check for required fields
    // check for sub-struct validity
  }

  private void writeObject(java.io.ObjectOutputStream out) throws java.io.IOException {
    try {
      write(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(out)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private void readObject(java.io.ObjectInputStream in) throws java.io.IOException, ClassNotFoundException {
    try {
      read(new org.apache.thrift.protocol.TCompactProtocol(new org.apache.thrift.transport.TIOStreamTransport(in)));
    } catch (org.apache.thrift.TException te) {
      throw new java.io.IOException(te);
    }
  }

  private static class ThriftUserUpdateStandardSchemeFactory implements SchemeFactory {
    public ThriftUserUpdateStandardScheme getScheme() {
      return new ThriftUserUpdateStandardScheme();
    }
  }

  private static class ThriftUserUpdateStandardScheme extends StandardScheme<ThriftUserUpdate> {

    public void read(org.apache.thrift.protocol.TProtocol iprot, ThriftUserUpdate struct) throws org.apache.thrift.TException {
      org.apache.thrift.protocol.TField schemeField;
      iprot.readStructBegin();
      while (true)
      {
        schemeField = iprot.readFieldBegin();
        if (schemeField.type == org.apache.thrift.protocol.TType.STOP) { 
          break;
        }
        switch (schemeField.id) {
          case 1: // C_UPDATES
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list0 = iprot.readListBegin();
                struct.cUpdates = new ArrayList<ThriftCreditUpdate>(_list0.size);
                ThriftCreditUpdate _elem1;
                for (int _i2 = 0; _i2 < _list0.size; ++_i2)
                {
                  _elem1 = new ThriftCreditUpdate();
                  _elem1.read(iprot);
                  struct.cUpdates.add(_elem1);
                }
                iprot.readListEnd();
              }
              struct.setCUpdatesIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          case 2: // M_UPDATES
            if (schemeField.type == org.apache.thrift.protocol.TType.LIST) {
              {
                org.apache.thrift.protocol.TList _list3 = iprot.readListBegin();
                struct.mUpdates = new ArrayList<ThriftMplUpdate>(_list3.size);
                ThriftMplUpdate _elem4;
                for (int _i5 = 0; _i5 < _list3.size; ++_i5)
                {
                  _elem4 = new ThriftMplUpdate();
                  _elem4.read(iprot);
                  struct.mUpdates.add(_elem4);
                }
                iprot.readListEnd();
              }
              struct.setMUpdatesIsSet(true);
            } else { 
              org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
            }
            break;
          default:
            org.apache.thrift.protocol.TProtocolUtil.skip(iprot, schemeField.type);
        }
        iprot.readFieldEnd();
      }
      iprot.readStructEnd();

      // check for required fields of primitive type, which can't be checked in the validate method
      struct.validate();
    }

    public void write(org.apache.thrift.protocol.TProtocol oprot, ThriftUserUpdate struct) throws org.apache.thrift.TException {
      struct.validate();

      oprot.writeStructBegin(STRUCT_DESC);
      if (struct.cUpdates != null) {
        if (struct.isSetCUpdates()) {
          oprot.writeFieldBegin(C_UPDATES_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.cUpdates.size()));
            for (ThriftCreditUpdate _iter6 : struct.cUpdates)
            {
              _iter6.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
      }
      if (struct.mUpdates != null) {
        if (struct.isSetMUpdates()) {
          oprot.writeFieldBegin(M_UPDATES_FIELD_DESC);
          {
            oprot.writeListBegin(new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, struct.mUpdates.size()));
            for (ThriftMplUpdate _iter7 : struct.mUpdates)
            {
              _iter7.write(oprot);
            }
            oprot.writeListEnd();
          }
          oprot.writeFieldEnd();
        }
      }
      oprot.writeFieldStop();
      oprot.writeStructEnd();
    }

  }

  private static class ThriftUserUpdateTupleSchemeFactory implements SchemeFactory {
    public ThriftUserUpdateTupleScheme getScheme() {
      return new ThriftUserUpdateTupleScheme();
    }
  }

  private static class ThriftUserUpdateTupleScheme extends TupleScheme<ThriftUserUpdate> {

    @Override
    public void write(org.apache.thrift.protocol.TProtocol prot, ThriftUserUpdate struct) throws org.apache.thrift.TException {
      TTupleProtocol oprot = (TTupleProtocol) prot;
      BitSet optionals = new BitSet();
      if (struct.isSetCUpdates()) {
        optionals.set(0);
      }
      if (struct.isSetMUpdates()) {
        optionals.set(1);
      }
      oprot.writeBitSet(optionals, 2);
      if (struct.isSetCUpdates()) {
        {
          oprot.writeI32(struct.cUpdates.size());
          for (ThriftCreditUpdate _iter8 : struct.cUpdates)
          {
            _iter8.write(oprot);
          }
        }
      }
      if (struct.isSetMUpdates()) {
        {
          oprot.writeI32(struct.mUpdates.size());
          for (ThriftMplUpdate _iter9 : struct.mUpdates)
          {
            _iter9.write(oprot);
          }
        }
      }
    }

    @Override
    public void read(org.apache.thrift.protocol.TProtocol prot, ThriftUserUpdate struct) throws org.apache.thrift.TException {
      TTupleProtocol iprot = (TTupleProtocol) prot;
      BitSet incoming = iprot.readBitSet(2);
      if (incoming.get(0)) {
        {
          org.apache.thrift.protocol.TList _list10 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
          struct.cUpdates = new ArrayList<ThriftCreditUpdate>(_list10.size);
          ThriftCreditUpdate _elem11;
          for (int _i12 = 0; _i12 < _list10.size; ++_i12)
          {
            _elem11 = new ThriftCreditUpdate();
            _elem11.read(iprot);
            struct.cUpdates.add(_elem11);
          }
        }
        struct.setCUpdatesIsSet(true);
      }
      if (incoming.get(1)) {
        {
          org.apache.thrift.protocol.TList _list13 = new org.apache.thrift.protocol.TList(org.apache.thrift.protocol.TType.STRUCT, iprot.readI32());
          struct.mUpdates = new ArrayList<ThriftMplUpdate>(_list13.size);
          ThriftMplUpdate _elem14;
          for (int _i15 = 0; _i15 < _list13.size; ++_i15)
          {
            _elem14 = new ThriftMplUpdate();
            _elem14.read(iprot);
            struct.mUpdates.add(_elem14);
          }
        }
        struct.setMUpdatesIsSet(true);
      }
    }
  }

}

